package directory.passive.markov;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

// FIXME rename
public class Prefix {
	private final List<Token> tokens;

	public Prefix(Token[] tokens) {
		this.tokens = Arrays.asList(tokens);
	}

	public Prefix(List<Token> tokens) {
		this.tokens = tokens;
	}

	public Prefix slide(Token newToken) {
		List<Token> newTokens = new ArrayList<>(this.tokens);
		newTokens.remove(0);
		newTokens.add(newToken);
		return new Prefix(newTokens);
	}

	@Override
	public String toString() {
		return "P=" + tokens;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + tokens.hashCode();
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Prefix other = (Prefix) obj;
		if (!tokens.equals(other.tokens))
			return false;
		return true;
	}

}
